/*
 * WSO2 API Manager - Developer Portal
 * This document specifies a **RESTful API** for WSO2 **API Manager** - **Developer Portal**. Please see [full OpenAPI Specification](https://raw.githubusercontent.com/wso2/carbon-apimgt/v6.7.206/components/apimgt/org.wso2.carbon.apimgt.rest.api.store.v1/src/main/resources/devportal-api.yaml) of the API which is written using [OAS 3.0](http://swagger.io/) specification.  # Authentication Our REST APIs are protected using OAuth2 and access control is achieved through scopes. Before you start invoking the API, you need to obtain an access token with the required scopes. This guide will walk you through the steps that you will need to follow to obtain an access token. First you need to obtain the consumer key/secret key pair by calling the dynamic client registration (DCR) endpoint. You can add your preferred grant types in the payload. A Sample payload is shown below. ```   {   \"callbackUrl\":\"www.google.lk\",   \"clientName\":\"rest_api_devportal\",   \"owner\":\"admin\",   \"grantType\":\"client_credentials password refresh_token\",   \"saasApp\":true   } ``` Create a file (payload.json) with the above sample payload, and use the cURL shown below to invoke the DCR endpoint. Authorization header of this should contain the base64 encoded admin username and password. **Format of the request** ```   curl -X POST -H \"Authorization: Basic Base64(admin_username:admin_password)\" -H \"Content-Type: application/json\"   \\ -d @payload.json https://<host>:<servlet_port>/client-registration/v0.17/register ``` **Sample request** ```   curl -X POST -H \"Authorization: Basic YWRtaW46YWRtaW4=\" -H \"Content-Type: application/json\"   \\ -d @payload.json https://localhost:9443/client-registration/v0.17/register ``` Following is a sample response after invoking the above curl. ``` { \"clientId\": \"fOCi4vNJ59PpHucC2CAYfYuADdMa\", \"clientName\": \"rest_api_devportal\", \"callBackURL\": \"www.google.lk\", \"clientSecret\": \"a4FwHlq0iCIKVs2MPIIDnepZnYMa\", \"isSaasApplication\": true, \"appOwner\": \"admin\", \"jsonString\": \"{\\\"grant_types\\\":\\\"client_credentials password refresh_token\\\",\\\"redirect_uris\\\":\\\"www.google.lk\\\",\\\"client_name\\\":\\\"rest_api_devportal\\\"}\", \"jsonAppAttribute\": \"{}\", \"tokenType\": null } ``` Next you must use the above client id and secret to obtain the access token. We will be using the password grant type for this, you can use any grant type you desire. You also need to add the proper **scope** when getting the access token. All possible scopes for devportal REST API can be viewed in **OAuth2 Security** section of this document and scope for each resource is given in **authorization** section of resource documentation. Following is the format of the request if you are using the password grant type. ``` curl -k -d \"grant_type=password&username=<admin_username>&password=<admin_password>&scope=<scopes separated by space>\" \\ -H \"Authorization: Basic base64(cliet_id:client_secret)\" \\ https://<host>:<gateway_port>/token ``` **Sample request** ``` curl https://localhost:8243/token -k \\ -H \"Authorization: Basic Zk9DaTR2Tko1OVBwSHVjQzJDQVlmWXVBRGRNYTphNEZ3SGxxMGlDSUtWczJNUElJRG5lcFpuWU1h\" \\ -d \"grant_type=password&username=admin&password=admin&scope=apim:subscribe apim:api_key\" ``` Shown below is a sample response to the above request. ``` { \"access_token\": \"e79bda48-3406-3178-acce-f6e4dbdcbb12\", \"refresh_token\": \"a757795d-e69f-38b8-bd85-9aded677a97c\", \"scope\": \"apim:subscribe apim:api_key\", \"token_type\": \"Bearer\", \"expires_in\": 3600 } ``` Now you have a valid access token, which you can use to invoke an API. Navigate through the API descriptions to find the required API, obtain an access token as described above and invoke the API with the authentication header. If you use a different authentication mechanism, this process may change.  # Try out in Postman If you want to try-out the embedded postman collection with \"Run in Postman\" option, please follow the guidelines listed below. * All of the OAuth2 secured endpoints have been configured with an Authorization Bearer header with a parameterized access token. Before invoking any REST API resource make sure you run the `Register DCR Application` and `Generate Access Token` requests to fetch an access token with all required scopes. * Make sure you have an API Manager instance up and running. * Update the `basepath` parameter to match the hostname and port of the APIM instance.  [![Run in Postman](https://run.pstmn.io/button.svg)](https://app.getpostman.com/run-collection/5bc0161b8aa7e701d7bf) 
 *
 * The version of the OpenAPI document: v2
 * Contact: architecture@wso2.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.wso2.am.integration.clients.store.api.v1.dto;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import com.fasterxml.jackson.annotation.JsonCreator;
/**
* WebhookSubscriptionDTO
*/

public class WebhookSubscriptionDTO {
        public static final String SERIALIZED_NAME_API_ID = "apiId";
        @SerializedName(SERIALIZED_NAME_API_ID)
            private String apiId;

        public static final String SERIALIZED_NAME_APP_ID = "appId";
        @SerializedName(SERIALIZED_NAME_APP_ID)
            private String appId;

        public static final String SERIALIZED_NAME_TOPIC = "topic";
        @SerializedName(SERIALIZED_NAME_TOPIC)
            private String topic;

        public static final String SERIALIZED_NAME_CALL_BACK_URL = "callBackUrl";
        @SerializedName(SERIALIZED_NAME_CALL_BACK_URL)
            private String callBackUrl;

        public static final String SERIALIZED_NAME_DELIVERY_TIME = "deliveryTime";
        @SerializedName(SERIALIZED_NAME_DELIVERY_TIME)
            private String deliveryTime;

        public static final String SERIALIZED_NAME_DELIVERY_STATUS = "deliveryStatus";
        @SerializedName(SERIALIZED_NAME_DELIVERY_STATUS)
            private Integer deliveryStatus;


        public WebhookSubscriptionDTO apiId(String apiId) {
        
        this.apiId = apiId;
        return this;
        }

    /**
        * Get apiId
    * @return apiId
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(example = "faae5fcc-cbae-40c4-bf43-89931630d313", value = "")
    
    public String getApiId() {
        return apiId;
    }


    public void setApiId(String apiId) {
        this.apiId = apiId;
    }


        public WebhookSubscriptionDTO appId(String appId) {
        
        this.appId = appId;
        return this;
        }

    /**
        * Get appId
    * @return appId
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(example = "faae5fcc-cbae-40c4-bf43-89931630d313", value = "")
    
    public String getAppId() {
        return appId;
    }


    public void setAppId(String appId) {
        this.appId = appId;
    }


        public WebhookSubscriptionDTO topic(String topic) {
        
        this.topic = topic;
        return this;
        }

    /**
        * Get topic
    * @return topic
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(example = "orderBooks", value = "")
    
    public String getTopic() {
        return topic;
    }


    public void setTopic(String topic) {
        this.topic = topic;
    }


        public WebhookSubscriptionDTO callBackUrl(String callBackUrl) {
        
        this.callBackUrl = callBackUrl;
        return this;
        }

    /**
        * Get callBackUrl
    * @return callBackUrl
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(example = "www.orderbooksite.com", value = "")
    
    public String getCallBackUrl() {
        return callBackUrl;
    }


    public void setCallBackUrl(String callBackUrl) {
        this.callBackUrl = callBackUrl;
    }


        public WebhookSubscriptionDTO deliveryTime(String deliveryTime) {
        
        this.deliveryTime = deliveryTime;
        return this;
        }

    /**
        * Get deliveryTime
    * @return deliveryTime
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(example = "faae5fcc-cbae-40c4-bf43-89931630d313", value = "")
    
    public String getDeliveryTime() {
        return deliveryTime;
    }


    public void setDeliveryTime(String deliveryTime) {
        this.deliveryTime = deliveryTime;
    }


        public WebhookSubscriptionDTO deliveryStatus(Integer deliveryStatus) {
        
        this.deliveryStatus = deliveryStatus;
        return this;
        }

    /**
        * Get deliveryStatus
    * @return deliveryStatus
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(example = "1", value = "")
    
    public Integer getDeliveryStatus() {
        return deliveryStatus;
    }


    public void setDeliveryStatus(Integer deliveryStatus) {
        this.deliveryStatus = deliveryStatus;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
        return true;
        }
        if (o == null || getClass() != o.getClass()) {
        return false;
        }
            WebhookSubscriptionDTO webhookSubscription = (WebhookSubscriptionDTO) o;
            return Objects.equals(this.apiId, webhookSubscription.apiId) &&
            Objects.equals(this.appId, webhookSubscription.appId) &&
            Objects.equals(this.topic, webhookSubscription.topic) &&
            Objects.equals(this.callBackUrl, webhookSubscription.callBackUrl) &&
            Objects.equals(this.deliveryTime, webhookSubscription.deliveryTime) &&
            Objects.equals(this.deliveryStatus, webhookSubscription.deliveryStatus);
    }

    @Override
    public int hashCode() {
        return Objects.hash(apiId, appId, topic, callBackUrl, deliveryTime, deliveryStatus);
    }


@Override
public String toString() {
StringBuilder sb = new StringBuilder();
sb.append("class WebhookSubscriptionDTO {\n");
    sb.append("    apiId: ").append(toIndentedString(apiId)).append("\n");
    sb.append("    appId: ").append(toIndentedString(appId)).append("\n");
    sb.append("    topic: ").append(toIndentedString(topic)).append("\n");
    sb.append("    callBackUrl: ").append(toIndentedString(callBackUrl)).append("\n");
    sb.append("    deliveryTime: ").append(toIndentedString(deliveryTime)).append("\n");
    sb.append("    deliveryStatus: ").append(toIndentedString(deliveryStatus)).append("\n");
sb.append("}");
return sb.toString();
}

/**
* Convert the given object to string with each line indented by 4 spaces
* (except the first line).
*/
private String toIndentedString(Object o) {
if (o == null) {
return "null";
}
return o.toString().replace("\n", "\n    ");
}

}

